package custom.array;

//import java.util.ArrayList;
//import java.util.Arrays;
import custom.draw.Plotter;
import java.util.*;
import java.lang.*; 
import custom.math.MathHelper; 

public class ArrayHelper {
	
	public static <T> void retClass(T o){
		System.out.println(o.getClass().getName());
	
	}
	
	
	public static double innerProduct(double[] a, double[] b){
    double product = 0; 
      for(int i = 0; i < a.length; i++){
        product += a[i]*b[i];
      }
    
    return product;
  }
	public static double[][] copy2D(double[][] a){
		
		double[][] b = new double[a.length][];
		for(int i = 0; i < a.length ; i++){
			b[i] = Arrays.copyOf(a[i], a[i].length); 	
		}
	
		return b; 
		
	} // copy2D method 

  public static double[] linterp(double[] a, int n){
    double[] lin = new double[n];
    double binsize = a.length/((double) n); 
    
    
    return lin; 
  }
  
  
  
	public static double[][] transpose(double[][] a){
		double[][] b = new double[a[0].length][a.length ];
		for(int i = 0; i < a.length; i++){
			for(int j = 0; j < a[i].length; j++){
				b[j][i] = a[i][j];
			}
		}
	
		return b; 
	}
		
//	public static double[][] dice(double[] a, int l){

//		// Instantiate return array 
//		double[][] ret; 
//		if(a.length % l == 0){
//			ret = new double[a.length/l][];
//			for(int out = 0; out < ret.length; out++){ ret[out] = new double[l]; } 	
//		} else {
//			ret = new double[a.length/l + 1][]; 
//			for(int i = 0; i < ret.length - 1; i++){ ret[i] = new double[l]; }
//			ret[ret.length - 1] = new double[a.length % l];
//		}

//		// Cycle a 	
//		for(int i = 0; i < a.length; i++){
//			ret[i/l][i%l] = a[i];	
//		}	

//		return ret; 

//	} // end dice 



///////////////////////////////////////////////////////////////


////public static <T> List<T[]> dice(T[] a, int l){

////		
////		// Instantiate return array
////		List<T[]> ret;
////		L = a.length/l;
////		if(! a.length % l == 0) L++;

////		// Cycle a 	
////		for(int i = 0; i < a.length; i++){
////			ret.add(a[i];	
////		}	

////		return ret; 

////	}  end dice 





///////////////////////////////////////////////////////////////

	
	public static double[][] invert(double[][] ori, int dim){ // 2D invert 
		// Inverts arrays along dimension dim
		// dim = 1 -> vertical, dim = 2 -> horizontal 
		double[][] ret = new double[ori.length][]; 
		
		if(dim == 1){
			for(int i = 0; i < ori.length; i++){
				ret[i] = invert(ori[i]);
			}
		}else if(dim == 2){
			for(int i = 0; i < ori.length; i++){ // cycle primary arrays in ori
				ret[i] = new double[ori[i].length];
				for(int j = 0; j < ori[i].length; j++){ // cycle secondary array in ori
					ret[i][j] = ori[ori.length - i - 1][j];
				}
			}
		}else{
			System.out.println("Error in array invert: Whoa Foo! Check yo' dimensions!");
			ret = null; 
		}
		
		
		return ret; 
	} // 2D invert 
	
	
	public static double[] invert(double[] ori){ // 1D invert 
		// invert 1D array
			double[] ret = new double[ori.length];
			
			for(int i = 0; i < ori.length; i++){
				ret[i] = ori[ori.length - i - 1];
			}
			return ret; 
		} // 1D invert 
	
	
	
	
	

	public static double[][] arraySubtract(double[][] a, double[][] b){
		if(a.length != b.length){
			System.out.println("Error: Arrays of Different Lengths!");
		}
		
		double[][] c = new double[a.length][];
		for(int i = 0; i < a.length; i++){
			c[i] = new double[a[i].length];
			if(a[i].length != b[i].length){
				System.out.println("Error: Arrays of Different Lengths!");
			}
			for(int j = 0; j < a[i].length; j++){
				c[i][j] = a[i][j] - b[i][j];
			}
		}
		
		return c; 
		
	} // end array subtract 
	
	public static double[] arraySubtract(double[] a, double[] b){
		
		if(a.length != b.length) System.out.println("Error: Arrays of Different Lengths!");

		double[] c = new double[a.length];
		
		for(int i = 0; i < a.length; i++){
			c[i] = a[i] - b[i];
		} // end for 

		return c; 
		
	} // end arraySubtract

	public static double[] arrayAdd(double[]... varargs){
			
		double[] ret = new double[varargs[0].length]; 
		
		for(int i = 0; i < varargs.length; i++){
			for(int j = 0; j < ret.length; j++){
				ret[j] = ret[j] + varargs[i][j];
			}
		}

		return ret; 
		
	} // end arrayAdd


	
	
	public static double[][] arrayAdd(double[][] a, double[][] b){
		if(a.length != b.length){
			System.out.println("Error: Arrays of Different Lengths!");
		}
		
		double[][] c = new double[a.length][];
		for(int i = 0; i < a.length; i++){
			c[i] = new double[a[i].length];
			for(int j = 0; j < a[i].length; j++){
				c[i][j] = a[i][j] + b[i][j];
			}
		}
		
		return c; 
		
	} // end array add 
	
	
	public static double[] arrayDivide(double[] a, double b){

		double[] c = new double[a.length];
		for(int i = 0; i < a.length; i++){
			c[i] = a[i]/b; 
		}
		return c; 
	} 
	public static double[][] arrayDivide(double[][] a, double b){
		double[][] c = new double[a.length][];
		for(int i = 0; i < a.length; i++){
			c[i] = new double[a[i].length];
			for(int j = 0; j < a[i].length; j++ ){
				c[i][j] = a[i][j]/b; 
			}
		}
		return c; 
	} 

	public static double[][] arrayAdd(double[][] a, double b){
		double[][] c = new double[a.length][];
		for(int i = 0; i < a.length; i++){
			c[i] = new double[a[i].length];
			for(int j = 0; j < a[i].length; j++){
				c[i][j] = a[i][j] + b; 
			}
		
		}	

		return c;
	} // end array add 
	
	public static double[][] arrayDivide(double[][] a, double[][] b){
		if(a.length != b.length){
			System.out.println("Error: Arrays of Different Lengths!");
		}
		
		double[][] c = new double[a.length][];
		for(int i = 0; i < a.length; i++){
			c[i] = new double[a[i].length];
			for(int j = 0; j < a[i].length; j++){
				c[i][j] = a[i][j] / b[i][j];
			}
		}
		
		return c; 
		
	} // end array divide 
	
  public static double[] arrayMean(List<double[]> arrayList){
    double[] ret = new double[arrayList.get(0).length];
    for(double[] d : arrayList) 
    ret = arrayAdd(ret, d);
    ret = arrayDivide(ret, arrayList.size());
    return ret;
  }

	public static double[] arrayMean(double[]... varargs){
		double[] a = arrayAdd(varargs);
		for(int i = 0; i < a.length; i++){ a[i] /= varargs.length; }
		return a;
	} // end arrayMean

	public static double mean(double[] a){
		double mean = 0;
		for(int i = 0; i < a.length; i++){ mean += a[i]; }
		mean /= a.length;
		return mean;
	} // end mean 
	
	public static double[] mean(double[][] a){
		double[] mean = new double[a.length];
		for(int i = 0; i < a.length; i++){ mean[i] = mean(a[i]); }
		return mean; 
	} // end mean 
	
	
	public static double[][] arrayMultiply(double[][] a, double[][] b){
		if(a.length != b.length){
			System.out.println("Error: Arrays of Different Lengths!");
		}
		
		double[][] c = new double[a.length][];
		for(int i = 0; i < a.length; i++){
			c[i] = new double[a[i].length];
			for(int j = 0; j < a[i].length; j++){
				c[i][j] = a[i][j] * b[i][j];
			}
		}
		
		return c; 
		
	} // end array multiply 
	

	public static double[][][] dice(double[][] a, double[] b){
	// Dice array a by array b 
		// For each position in b, calculate trend to next element
		// If trend is different, mark that point 
		// For each mark point, save elements in a between that point and next point 

		ArrayList<Integer> MarkedPoints = new ArrayList<Integer>();

		double measured_trend = 0;
 		double new_trend = 0;
		for(int i = 1; i < b.length -1; i++){
			measured_trend = MathHelper.round(b[i] - b[i-1], 6);
							
			if(i == 1 || new_trend != measured_trend){ 
				MarkedPoints.add(new Integer(i));
				new_trend = MathHelper.round(b[i+1] - b[i], 6); 
			} // end if 	
			
		} // end for loop (through b )

		double[][][] ret = new double[MarkedPoints.size()][][];
		for(int i = 0; i < MarkedPoints.size(); i++){
			// If at last marked point, go to end of array, else go to next marked point 
			int stoppt = i == MarkedPoints.size() - 1  ? a.length : MarkedPoints.get(i+1);
			int index = 0; 
			double[][] tmp = new double[stoppt - MarkedPoints.get(i)][];
			for(int j = MarkedPoints.get(i); j < stoppt ; j++){
				tmp[index] = Arrays.copyOf(a[j], a[j].length);
				index++;	
			} // assign a-range to tmp array 

			ret[i] = tmp; 
		 		
		} // cycle marked points 

		
		return ret; 	
			
	} // end dice by array 
  
  
  
  

	public static double[][] convergeData(double[][] _a, int timecol){
		// Expects data in column format 
    
    // Read in array from file 
		// Sort by time 
		// Dice array by timecol 
		// Create return array of length of 3D array
		// For each 2D array (grouped by time values), sum all 1D arrays (rows) and divide by length --> ArrayMean
		//	- store result in return array (which is 2D)
		double[][] a = copy2D(_a); // Create working array 
		a = ArrayHelper.sort(a, timecol); // Sort array by time column 
    
    // Create Map<Double, ArrayList<double[]>
    Map<Double, ArrayList<double[]>> point_map = new HashMap<Double, ArrayList<double[]>>(); 
    // Cycle time points (rows) of a. If time value not in map, add new entry to map
    for(int row = 0; row < a.length; row++){
      Double current_time_val = new Double(MathHelper.round(a[row][timecol], 5));
      if(! point_map.containsKey(current_time_val)) 
      point_map.put(current_time_val, new ArrayList<double[]>()); 
      point_map.get(current_time_val).add(a[row]);
    }
    // Preallocate return array
    double[][] converged_data = new double[point_map.keySet().size()][a[0].length];
    // Cycle map, and average array list values
    Iterator<Double> keyit = point_map.keySet().iterator();
    int index = 0;
    while(keyit.hasNext()){
      Double tvalue = keyit.next();
      converged_data[index] = arrayMean(point_map.get(tvalue));
      index++;
    }
    return converged_data; 
  }
	
	

	public static double[] arrayListtoArray(ArrayList<Double> List){
		
		double[] a = new double[List.size()];

		int index = 0;
		for(Double d : List){
			a[index] = d.doubleValue();
			index++;
		}
		return a; 
	} // End arrayListtoArray
	
	public static double[][] sort(int dim, double[][] a, int line){
	// In accordance with dlmread and dlmwrite, each row of a 2D array represents a primitive array 
		double[][] array = copy2D(a);
		if(dim == 2) array = transpose(array);
		Arrays.sort(array, new ArraySorter(line));
		if(dim == 2) array = transpose(array);
		return array; 
	}

	public static double[][] sort(double[][] a){ return sort(1,a,0); }
	public static double[][] sort(double[][] a, int line){ return sort(1,a,line); }
	public static double[][] sort(int dim, double[][] a){ return sort(dim, a, 0); }

	public static double[] sort(double[] _a){ double[] a = new double[_a.length]; Arrays.sort(a); return a; }

		
	public static class ArraySorter implements Comparator<double[]>{
    // Sorts a collection of arrays, based on the sort_line index of each array
    // Intended to sort arrays in "column format" i.e. a list of data points, such that
    // each column represents a parameter and each row is a different point (array)
		int sort_line = 1;	

		//******* Constructors
		public ArraySorter(int _sort_line){
			sort_line = _sort_line;
		}// end constructor 
		public ArraySorter(){
		}
		//******** compare 
		public int compare(double[] a, double[] b){
			if(a[sort_line] < b[sort_line]) return -1;
			else if(a[sort_line] > b[sort_line]) return 1;
			else return 0;
		}// end compare 
	} // end class ArraySorter

} // end class 
