package custom.array; 
import java.io.*; 
import java.util.*; 

public class arrayio {
  
  PrintWriter pw; 
	BufferedReader fr; 
	File fobj; 
	public arrayio(){ } // end constructor 
	public arrayio(String file){ setFile(file); } // end constructor 
	public void setFile(String filename){ fobj = new File(filename);} // end setFile
	public void setFile(File file){ if(fobj != file) fobj = file; }

	//********* dlmwrite - 1D array (File parameter)
	public void dlmwrite(File file, double[] a , String dlm, boolean append) {
	
    
		// setFile
		setFile(file); 

		try{
		// Create PrintWriter object 
		pw = new PrintWriter(new FileOutputStream(fobj, append));

		// Cycle a
		for(int i = 0; i < a.length ; i++){
			pw.print(a[i] + dlm);
		} // end cycle a 
    pw.print("\n");
		pw.close(); 
		}catch(FileNotFoundException f){
			System.out.println("FileNotFoundException: Error in saving output to " + fobj.getAbsolutePath() );
		} catch(IOException e){
			System.out.println("IOException: Error in saving output to " + fobj.getAbsolutePath() );
		}// end catch block

	} // end dlmwrite - 1D 

	// String parameter 
	public void dlmwrite(String file, double[] a,String dlm, boolean append) {File f = new File(file); dlmwrite(file,a,dlm,append);} 
	public void dlmwrite(String file, double[] a)  { dlmwrite(file, a, "\n", false); } 
	public void dlmwrite(String file, double[] a, boolean append)  { dlmwrite(file, a, "\n", append); } 
	public void dlmwrite(String file, double[] a,String dlm)  { dlmwrite(file, a,dlm, false); } 
	// File parameter given 
	public void dlmwrite(File file, double[] a)  { dlmwrite(file, a, "\n", false); } 
	public void dlmwrite(File file, double[] a, boolean append)  { dlmwrite(file, a, "\n", append); } 
	public void dlmwrite(File file, double[] a,String dlm)  { dlmwrite(file, a,dlm, false); } 
	
	// default file: 
	public void dlmwrite(double[] a , String dlm, boolean append)  { dlmwrite(this.fobj, a,  dlm, append); }
	public void dlmwrite(double[] a)  { dlmwrite(this.fobj, a, "\n", false); } 
	public void dlmwrite(double[] a, boolean append)  { dlmwrite(this.fobj, a, "\n", append); } 
	public void dlmwrite(double[] a,String dlm)  { dlmwrite(this.fobj, a , dlm, false); } 

	//*********** dlmwrite (2D)
	public void dlmwrite(File file, double[][] a, String dlm, boolean append)  {
		
		// set fobj 
		setFile(file); 


		try{
			// Create PrintWriter object 
			pw = new PrintWriter(new FileOutputStream(fobj, append));
			
			// Cycle a
			for(int i = 0; i < a.length ; i++){
				for(int j = 0; j < a[i].length; j++){
					pw.print(a[i][j] + dlm); 
				}
				pw.print("\n");
			} // end cycle a 

			pw.close(); 
		}catch(FileNotFoundException f){
			System.out.println("FileNotFoundException: Error in saving output to " + fobj.getAbsolutePath() );
		} catch(IOException e){
			System.out.println("IOException: Error in saving output to " + fobj.getAbsolutePath() );
		}// end catch block

		
	} // end dlmwrite - 2D 


	
	public void dlmwrite(String file, double[][] a, String dlm, boolean append){File f = new File(file); dlmwrite(f,a,dlm,append);}
	public  void dlmwrite(String file, double[][] a)  { dlmwrite(file, a, "\t", false); } 
	public  void dlmwrite(String file, double[][] a, boolean append)  { dlmwrite(file, a, "\t", append); } 
	public  void dlmwrite(String file, double[][] a,String dlm)  { dlmwrite(file, a,dlm, false); } 
	// default file: 
	public  void dlmwrite(double[][] a , String dlm, boolean append)  { dlmwrite(this.fobj.getName(), a, dlm, append); }
	public  void dlmwrite(double[][] a)  { dlmwrite(this.fobj.getName(), a, "\t", false); } 
	public  void dlmwrite(double[][] a, boolean append)  { dlmwrite(this.fobj.getName(), a, "\t", append); }
	public  void dlmwrite(double[][] a,String dlm)  { dlmwrite(this.fobj.getName(), a , dlm, false); } 
	// file object: 
	public  void dlmwrite(File file, double[][] a)  { dlmwrite(file, a, "\t", false); } 
	public  void dlmwrite(File file, double[][] a, boolean append)  { dlmwrite(file, a, "\t", append); } 
	public  void dlmwrite(File file, double[][] a,String dlm)  { dlmwrite(file, a,dlm, false); } 


//-------------------------------------- dlmwrite 
//************************************** 
//-------------------------------------- dlmread 

	public double[] dlmread(File file, String dlm){

		// Set fobj 
		setFile(file); 

		// Create array list 	
		ArrayList<Double> alist = new ArrayList<Double>(); 

		// Create reader 
		try{
			fr = new BufferedReader(new FileReader(fobj)); 
			String line = null; 
			while((line = fr.readLine()) != null){
				// Create string tokenizer 
				StringTokenizer st = new StringTokenizer(line, dlm); 
				// Extract tokens 
				while(st.hasMoreTokens()){ alist.add( Double.parseDouble(st.nextToken())   ); } // end inner while 
			} // end outer while 

			// Close stream 
			fr.close();
		}catch(FileNotFoundException f){
			System.out.println("FileNotFoundException: Could not open " + fobj.getAbsolutePath() + " for reading." );
		}catch(IOException e){
			System.out.println("IOException: Could not open " + fobj.getAbsolutePath() + " for reading." );
		}
		
		// Convert alist to double[]
		double[] ret = new double[alist.size()];
		int index = 0; 
		for(Double D : alist){
			ret[index] = D.doubleValue(); 
			index++; 
		} // end for loop 

		return ret; 

	
	} // end dlmread 


// String parameter 
public double[] dlmread(String file, String dlm) { File f = new File(file); double[] ret = dlmread(file, dlm); return ret; }
public double[] dlmread(String file) {  double[] ret = dlmread(new File(file), "\n\t \r"); return ret; }
// File parameter 
public double[] dlmread(File file) { return dlmread(file, "\n\t \r");}
// Default file
public double[] dlmread() { double[] ret = dlmread(fobj, "\n\t \r"); return ret; }

//******* dlmread2D

public double[][] dlmread2D(File file, String dlm){
// Works fine with default dlm 
		// Set fobj 
		setFile(file); 

		// Create array list 	
		ArrayList<double[]> alist = new ArrayList<double[]>(); 

		// Create reader 
		try{

			fr = new BufferedReader(new FileReader(fobj)); 
			String line = null; 
			while((line = fr.readLine()) != null){

				// Create string tokenizer 
				StringTokenizer st = new StringTokenizer(line, dlm); 
				// Instantiate double array
				double[] tmp = new double[st.countTokens()];
				for(int i = 0; i < tmp.length; i++){
					tmp[i] = Double.parseDouble(st.nextToken());
				}

				// Add primitive array to arraylist
				alist.add(tmp);
				
			} // end outer while 

			// Close stream 
			fr.close(); 
			
		} catch(IOException e){ 
			System.out.println("File " + file + " not found for reading.");
			System.exit(0);
		}
		
		// Convert alist to double[][]
		double[][] ret = new double[alist.size()][];
		int index = 0; 
		for(double[] d : alist){
			ret[index] = d; 
			index++; 
		} // end for loop 

		return ret; 

} // dlmread2D

public double[][] dlmread2D(File file) { return dlmread2D(file, "\n\t \r"); }






} // end class 




