package custom.draw;
import java.awt.Color;
import java.lang.Object;
import org.opensourcephysics.controls.*;
import org.opensourcephysics.display.*;
import java.util.*;
import javax.swing.JFrame;

public class BufferedAnimation {
	
		PlottingPanel panel; 
		DrawingFrame frame; 
		DrawableBuffer buffer;
		 
		
		public BufferedAnimation(double xmin, double xmax , double ymin, double ymax){
			
			panel = new PlottingPanel("x", "y", null);
			frame = new DrawingFrame(panel);
			buffer = new DrawableBuffer(); 
			panel.addDrawable(buffer);
			frame.setPreferredMinMax(xmin, xmax, ymin, ymax);
			frame.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
			frame.setVisible(true); 
		} // end constructor 
	
		public void add(Drawable shape){
			panel.addDrawable(shape); 		
//			if(shape instanceof DrawableShape) panel.addDrawable((DrawableShape) shape);
//			else if(shape instanceof DrawableGroup) panel.addDrawable((DrawableGroup) shape);   
		} // end add 
	
		public void add(Collection<? extends Drawable> shapes){
			for(Drawable obj : shapes){
				add(obj); 
			}
		} // end add (Collection of shapes)
	
		public void addToBuffer(Drawable shape){
			buffer.addDrawable(shape); 
//			if(shape instanceof DrawableShape) buffer.addDrawable((DrawableShape) shape);
//			else if(shape instanceof DrawableGroup) buffer.addDrawable((DrawableGroup) shape);
		} // end addToBuffer
		
		public void addToBuffer(Collection<? extends Drawable> shapes){
			for(Drawable obj : shapes){
				addToBuffer(obj); 
			} 
		} // end addToBuffer (Collection of shapes)
		
		public void update(){
			panel.repaint(); 
		} // end update 
	
		public void clear(){
			// Clear panel
			panel.clear();
			// Add buffer to panel again
			buffer = new DrawableBuffer(); 
			panel.addDrawable(buffer);
		} // end clear 

		public void remove(Drawable shape){
			panel.removeDrawable(shape);
		}

//		public <T extends Drawable> void removeType(Class<T> c){
//			panel.removeObjectsOfClass(c);
//		}

		public void setCloseAction(String CloseAction){
			if(CloseAction.equalsIgnoreCase("exit")) frame.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);   
			else if(CloseAction.equalsIgnoreCase("dispose")) frame.setDefaultCloseOperation(javax.swing.JFrame.DISPOSE_ON_CLOSE);
			else if(CloseAction.equalsIgnoreCase("nothing")) frame.setDefaultCloseOperation(javax.swing.JFrame.DO_NOTHING_ON_CLOSE);
			else if(CloseAction.equalsIgnoreCase("hide")) frame.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
		}

	
} // End BufferedAnimation 
