/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package custom.draw;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.ArrayList;
import javax.swing.JInternalFrame;
import javax.swing.JPanel;


/**
 *
 * @author danhurwitz
 */
public class Legend extends JPanel{

  Color[] cmap = null;
  ArrayList<String> labels = new ArrayList<String>();
  
  // constructor(figure) : adds internal frame to figure, adds jpanel to that frame 
  public Legend(String... _labels){
    for(String s : labels){
      this.labels.add(s);
    }
    setOpaque(true);
    setBackground(Color.WHITE);
  } // end constructor 
  
  public void setLegendLabels(String... _labels ){
    for(String s : _labels){
      labels.add(s);
    }
    this.repaint();
  }
  
  public void addToLegend(String s){
     labels.add(s);
     this.repaint();
  }
  
  public void setCmap(Color[] cmap){
    this.cmap = cmap;
  }
  
  public void paintComponent(Graphics g){
		// Consider cycling data sets, not labels, so can preset legend?
			super.paintComponent(g);
      // Set Font
      Font font = new Font(Font.SANS_SERIF,Font.BOLD,20);
      g.setFont(font);
			// Get Font Metrics
			FontMetrics fm = g.getFontMetrics(); 
			// Draw Strings in LegendLabels
			int y = fm.getAscent() + fm.getLeading();
			int dataindex = 0;
			for(String s : labels){
				// Set Color 
				g.setColor(cmap[dataindex]);
				// Draw String 
				g.drawString(s, 1, y);
				// Advance y position 
				y += fm.getHeight();
				dataindex++;
			}
			// Set Size of Legend
			
		} // drawLegendLabels
  
  
  
} // end class 








//
//private void updateLegend(){
//
//
//			// Check if LegendLabels is empty
//			if(LegendLabels.isEmpty()) return; 
//			// Check if there is legend 
//			if(Legend == null ) createLegend();
//			// Clear labels in legend (Might have to delete JInternalFrame Legend and recreate) 
//			Legend.getContentPane().removeAll();
//			// Draw Labels 
//			drawLegendLabels();
//		} // updateLegend
//
//		
//		
//		private void createLegend(){
//			Legend = new JInternalFrame("Legend", true, true);
//			Legend.setMinimumSize(new Dimension(100,80));
//			JPanel legendPanel = new JPanel();
//			Legend.add(legendPanel);
//			Legend.pack();
//			frame.add(Legend, new Integer(2));
//			Dimension d = frame.getSize(); 
//			Legend.setLocation((int)(0.7*d.getWidth()), (int) (d.getHeight()/2));
//			Legend.setSize(100,100);
//			Legend.setVisible(true);
//		} // end createLegend
//
