package custom.io;

import java.lang.Object;
import java.io.File;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.beans.XMLEncoder;
import java.beans.XMLDecoder;
import java.io.FileNotFoundException;
import java.lang.Class;

/**
 *
 * @author danhurwitz
 */
public class ioXML {
// Contains Encoding and Decoding methods 

  public static <T> void write(T obj, File f) {

    try {
      XMLEncoder encoder =
              new XMLEncoder(
              new BufferedOutputStream(
              new FileOutputStream(f)));
      encoder.writeObject(obj);
      encoder.close();
    } catch (FileNotFoundException e) {
      System.out.println("FileNotFoundException: Error writing object of type" + obj.getClass().getName() + "to file " + f.getAbsolutePath());
    } // end catch 


  } // end write 

  public static <T> T read(File f) {

    T obj = null;
    try {
      XMLDecoder decoder =
              new XMLDecoder(new BufferedInputStream(
              new FileInputStream(f)));
      obj = (T) decoder.readObject();
      decoder.close();
      return obj;
    } catch (FileNotFoundException e) {
      System.out.println("FileNotFoundException: Error reading object of type" + obj.getClass().getName() + "from file " + f.getAbsolutePath());
    } // end catch 

    return obj;

  } // end read 
} // end class 
