package custom.math;

import java.util.Arrays;
import java.util.Random;

public class MathHelper {

	private static	Random random = new Random();

	public static double[] rotate(double[] pt, double[] axis, double theta){
		double[][] rot = {{Math.cos(theta) , -Math.sin(theta)} , {Math.sin(theta) , Math.cos(theta)}  }; // rotation matrix
		double[] newpts = new double[2]; 
		    
	        double[] fixedpt = {pt[0] - axis[0], pt[1] - axis[1]};  	
		
			newpts[0] = dot(rot[0], fixedpt ) + axis[0];
			newpts[1] = dot(rot[1], fixedpt ) + axis[1];
		
		return newpts;
	} // rotate method 

	public static double[][] rotate(double[][] pts, double[] axis, double theta){
		
		double[][] newpts = new double[pts.length][2]; 
		
		for(int pt = 0; pt < pts.length; pt++){
			newpts[pt] = Arrays.copyOf(rotate(pts[pt], axis, theta), 2);
		} // for loop 
		return newpts;
	} // rotate method 
	
	
	// Generate random points
		public static double[][] GeneratePoints(double modelx, double modely, int npts){
			
			Random random = new Random(); 
			double[][] pts = new double[npts][2];
			for(int i = 0; i < npts; i++){
				pts[i] = new double[]{modelx*random.nextDouble() , modely*random.nextDouble()}; 
			}
			
			return pts; 
			
		} // end GeneratePoints
		
		
		// Generate random points
				public static double[][] GeneratePoints(double modelx, double modely, int npts, double diameter){
					
					Random random = new Random(); 
					double[][] pts = new double[npts][2];
					for(int i = 0; i < npts; i++){
						pts[i] = new double[]{modelx*random.nextDouble() , modely*random.nextDouble()}; 
					}
					
					int counter = 0;
					for(int i = 0; i < pts.length; i++){
						for(int j = 0; j < pts.length; j++){
							if(pts[i] != null && pts[j] != null){
							if(distance(pts[i],  pts[j]) < diameter && i != j){
								pts[i] = null; 
								counter++;
							}
							}
						}
					}
					
					double[][] nonnullpts = new double[pts.length - counter][];
					if(counter != 0){
						int index = 0;
						for(int i = 0; i < pts.length; i++){
							if( pts[i] != null){
							nonnullpts[index] = pts[i];
							index++;
							}
						}
					}else{
						nonnullpts = pts;
					}
					
					

					return nonnullpts; 
					
					
		} // end GeneratePoints
		
		
		
		
		
		
		
		// Distance method 
		public static double distance(double[] a, double[] b){
			double d = Math.sqrt( (b[0] - a[0])*(b[0] - a[0]) +  (b[1] - a[1])*(b[1] - a[1]) );
			return d; 
		} // end distance method 
		
		
		public static double distance(double[][] a){
			double[] b = a[0];
			double[] c = a[1];
			double d = distance(b,c);
			return d; 
		} // end Distance 
	
		public static double[] findDirection(double[][] endpts){
			double[] direction = findDirection(endpts[0], endpts[1]); 
			return direction;
		} // End findDirection
		
		
		public static double[] findDirection(double[] a, double[] b){
			double[] direction = null; 
			double D = distance(a,b);
			if(D > 0.00001){
			  direction = new double[] {(b[0] - a[0])/D, (b[1] - a[1])/D   }; 
			} else{
				double rnum = random.nextDouble();
				direction = new double[] {Math.cos(rnum), Math.sin(rnum)};// end if 
			} 
			
			return direction; 
			
		} // End findDirection
		
		
		public static double dot(double[] a, double[] b){
			
			double product = 0;
			for(int i=0; i < a.length; i++){
				product += a[i]*b[i];
				}
			return product;
		} // End dot
	
	
	
	
	
		public static double[] findMidpoint(double[] pt1, double[] pt2){
			
			double[] midpoint = new double[2]; 
			
			if (pt1[0] == pt2[0] && pt1[1] == pt2[1]){
				midpoint[0] = pt1[0];
				midpoint[1] = pt1[1];
			}else {
				midpoint[0] = (pt1[0] + pt2[0])/2;
				midpoint[1] = (pt1[1] + pt2[1])/2;  
			 } // if-else
		
			return midpoint;
		
		} // END findMidpoint 2 points
		
		public static double[] findMidpoint(double[][] endpts){
			
			double[] midpoint = findMidpoint(endpts[0], endpts[1] );
			return midpoint;
			
		} // end findMidpoint (2D array)
	
	
	
		public static double round(double num, int digit){
		
			double xpon = Math.pow(10, (double) digit);
			return Math.round(xpon*num)/xpon; 
		
		}
	
	
	
	
	
	
	
	
	
}
