package diffusion;

import java.awt.Color;
import java.awt.Transparency;
import java.io.File;
import java.io.FileWriter; 
import java.io.BufferedWriter;
import java.io.IOException;
import java.math.*;
import java.util.*;

import org.opensourcephysics.frames.*;
import org.opensourcephysics.display3d.simple3d.*;
import org.opensourcephysics.controls.*;
import org.opensourcephysics.numerics.*;


	public class model {
		Display3DFrame frame5;//Ras1 frame
		Display3DFrame frame6;//GAP frame
		Display3DFrame frame7;
		PlotFrame Ras1GTPArc;
		PlotFrame Ras1GDPArc;
		PlotFrame Gap1Arc;
		PlotFrame GefArc;
		PlotFrame GefCyto;
		ElementSphere sphere1;  //top tip
		ElementSphere sphere2;  //bottom tip
		ElementCylinder cylinder;
		ElementSphere[] point;
		ElementSphere[] surfacePoint;
		nodeInitialization[][][] node;
		nodeInitialization[][][][] surfaceNode;
		private double time=0.;
		private double dt;
		private double length, radius, DGTP, DGDP,Smin,Smax,DGAP,k0p,k1p,k2p,k1n,k2n,k3n,c_sat,r_GAP,r_noise,r_GDP,r_GTP,Ec_total,T,visualizationTime;
		private int h,nx,ny,nz,totNumNodes;
		private double maxGTP, initialGTP, initialGDP;
		private double lx,ly,lz; //each node dimensions
		private double[][] dGeodesic,sGeodesic;  //voronoi diagram geodesic distances
		private VoronoiDiagram[] voronoiDiagram;
		private ElementPolygon[] polygon, polygon2,polygon3,polygontest;
		private int colorplot = 0; // color of concentration curve at a given time
		double maxRas1;
		double maxGap1;
		double bleachPhi; //phi angle on the lower half sphere for FRAP experiment 
		int bleachFlag;
		boolean showAnimation;
		private boolean ModelFinished = false; 
		SaveData GAP;
		SaveData GTP;
		SaveData GDP;
		SaveData GEF;
		SaveData GAPrecruitment;
		SaveData EcTimeValues;
		SaveData Area;
		//SaveData VoronoiDiagramsData;
		
		public model(){
			
		}

	public void concentrationInit(){
		System.out.println("concentration Init................T="+T+"            DGTP="+DGTP+"          DGDP="+DGDP+"          DGAP="+DGAP+"		k0p="+k0p+"		k1p="+k1p+"		k2p="+k2p+"		k1n="+k1n+"          k2n="+k2n+"		k3n="+k3n+"		r_GDP="+r_GDP+"		r_GTP="+r_GTP+"		r_GAP="+r_GAP+"		c_sat="+c_sat+"		h="+h+"		r_noise="+r_noise+ "      showAnimation="+showAnimation);   
		Ec_total=100;  //Total number of GEF molecules
		maxRas1=0;
		
		double totalArea=calculationOfVoronoiDiagramsArea();
		for(int i=0;i<totNumNodes;i++){
			voronoiDiagram[i].GTP=0;    
			voronoiDiagram[i].GDP=Math.random()*7*Math.pow(10, 3)/totalArea;   
			voronoiDiagram[i].GAP=0.;
			voronoiDiagram[i].GAPlabeled=0;    
			voronoiDiagram[i].totGAP=voronoiDiagram[i].GAP+voronoiDiagram[i].GAPlabeled;
			
			maxRas1+=(voronoiDiagram[i].GTP+voronoiDiagram[i].GDP)*voronoiDiagram[i].area;     //Total number of Ras1 molecules
			
		}
		System.out.println("j+ ="+maxRas1/totalArea);
		
		System.out.println("Ras1 initial Concentration ="+(maxRas1/totalArea)+"          max Ras1="+maxRas1+"       total Area="+totalArea+"       total volume="+ VolumeCalculation());
	}
	
	public void savingDataInit(){
		 GAP=new SaveData("GAP");
		 GTP=new SaveData("GTP");
		 GDP=new SaveData("GDP");
		 GEF=new SaveData("GEF");
		 GAPrecruitment=new SaveData("GAP_recruitment");
		 EcTimeValues=new SaveData("EcTimeValues");
		 Area=new SaveData("Area");
		 //VoronoiDiagramsData=new SaveData("VoronoiDiagramsData");
		 
		 GAP.SetFileName(DGAP,k0p,k1p,k2p,k2n,k3n,r_GAP,c_sat,r_noise);
		 GTP.SetFileName(DGAP,k0p,k1p,k2p,k2n,k3n,r_GAP,c_sat,r_noise);
		 GDP.SetFileName(DGAP,k0p,k1p,k2p,k2n,k3n,r_GAP,c_sat,r_noise);
		 GEF.SetFileName(DGAP,k0p,k1p,k2p,k2n,k3n,r_GAP,c_sat,r_noise);
		 GAPrecruitment.SetFileName(DGAP,k0p,k1p,k2p,k2n,k3n,r_GAP,c_sat,r_noise);
		 EcTimeValues.SetFileName(DGAP,k0p,k1p,k2p,k2n,k3n,r_GAP,c_sat,r_noise);
		 Area.SetFileName(DGAP,k0p,k1p,k2p,k2n,k3n,r_GAP,c_sat,r_noise);
		// VoronoiDiagramsData.SetFileName(DGAP,GAPhydro,k0,k1,k2,c1,c2,k,r_noise);
		
	}
	
	// EVOLVE MODEL START

	public void doStep(boolean showAnimation){
		this.showAnimation=showAnimation;
		Ras1GDPArc.clearData();
		Ras1GTPArc.clearData();
		Gap1Arc.clearData();
		GefArc.clearData();
		
		double volume= VolumeCalculation();
		double f=0.;
		for (int i=0; i<totNumNodes; i++){
			f += (k1p*voronoiDiagram[i].GTP+k2p*voronoiDiagram[i].GTP*voronoiDiagram[i].GTP)*(1/volume)*voronoiDiagram[i].area;
		}
		double Ec = Ec_total/(1+f);
		
		SaveDataStep(Ec,volume,time);
		if(showAnimation){
		double maxGTPratioPixel=voronoiDiagram[0].GTP/(voronoiDiagram[0].GTP+voronoiDiagram[0].GDP+1);
		double currentGTPratioPixel=voronoiDiagram[0].GTP/(voronoiDiagram[0].GTP+voronoiDiagram[0].GDP+1);
		int i_maxGTPratioPixel=0;
		for(int i=0;i<totNumNodes;i++){
			currentGTPratioPixel=voronoiDiagram[i].GTP/(voronoiDiagram[i].GTP+voronoiDiagram[i].GDP+1);
			if(currentGTPratioPixel>maxGTPratioPixel){
				maxGTPratioPixel=currentGTPratioPixel;
				i_maxGTPratioPixel=i;
			}
		}
		plotRas1Arc(i_maxGTPratioPixel);
		plotGefArc(Ec,volume,i_maxGTPratioPixel);
		plotGap1Arc(i_maxGTPratioPixel);
		GefCyto.append(0, time, Ec);

		}

		if(time >= T ){
			ModelFinished = true; 
			return;
		} 
		
		for(int i=0; i<((int) (visualizationTime/dt)); i++){ 
			doStepdt();
		}
		
	}


	public void doStepdt(){
		double[] totalFluxGTP= new double[totNumNodes];
		double[] totalFluxGDP= new double[totNumNodes];
		double[] totalFluxGAP = new double[totNumNodes];
		double[] totalFluxGAPlabeled = new double[totNumNodes];
		double[] reaction = new double[totNumNodes];
		double[] reactionGDP = new double[totNumNodes];
		double[] reactionGAP = new double[totNumNodes];
		double[] reactionGAPlabeled = new double[totNumNodes];
		double lambdas = radius;
		double volume= VolumeCalculation();
		double totalArea=calculationOfVoronoiDiagramsArea();
		time += dt;
		
		double f=0.;
		for (int i=0; i<totNumNodes; i++){
			f += (k1p*voronoiDiagram[i].GTP+k2p*voronoiDiagram[i].GTP*voronoiDiagram[i].GTP)*(1/volume)*voronoiDiagram[i].area;
		}
		double Ec = Ec_total/(1+f);
		
		for(int i=0;i<totNumNodes;i++){
			totalFluxGTP[i]=0.;
			totalFluxGDP[i]=0.;
			totalFluxGAP[i]=0.;
			totalFluxGAPlabeled[i]=0.;
			
			for(int j=0;j<voronoiDiagram[i].projection.length;j++){
					
					totalFluxGTP[i] += DGTP*(voronoiDiagram[(int)voronoiDiagram[i].projection[j][3]].GTP-voronoiDiagram[i].GTP)*sGeodesic[i][(int)voronoiDiagram[i].projection[j][3]]/dGeodesic[i][(int)voronoiDiagram[i].projection[j][3]];
					totalFluxGDP[i] += DGDP*(voronoiDiagram[(int)voronoiDiagram[i].projection[j][3]].GDP-voronoiDiagram[i].GDP)*sGeodesic[i][(int)voronoiDiagram[i].projection[j][3]]/dGeodesic[i][(int)voronoiDiagram[i].projection[j][3]];
					totalFluxGAP[i] += DGAP*(voronoiDiagram[(int)voronoiDiagram[i].projection[j][3]].GAP-voronoiDiagram[i].GAP)*sGeodesic[i][(int)voronoiDiagram[i].projection[j][3]]/dGeodesic[i][(int)voronoiDiagram[i].projection[j][3]];
					totalFluxGAPlabeled[i] += DGAP*(voronoiDiagram[(int)voronoiDiagram[i].projection[j][3]].GAPlabeled-voronoiDiagram[i].GAPlabeled)*sGeodesic[i][(int)voronoiDiagram[i].projection[j][3]]/dGeodesic[i][(int)voronoiDiagram[i].projection[j][3]];
					double rand=Math.random();
					reaction[i] = k0p*(k1p*voronoiDiagram[i].GTP+k2p*voronoiDiagram[i].GTP*voronoiDiagram[i].GTP)*voronoiDiagram[i].GDP*(Ec/volume)-(k1n+k2n*voronoiDiagram[i].totGAP)*voronoiDiagram[i].GTP+rand*r_noise*voronoiDiagram[i].GDP-r_GTP*voronoiDiagram[i].GTP;     //*Ec  //*voronoiDiagram[i].GAP  //Math.exp(-voronoiDiagram[i].distanceFromTheCloserTip(length,radius)/lambdas)
					reactionGDP[i] = r_GDP*(maxRas1/totalArea)-r_GDP*voronoiDiagram[i].GDP-k0p*(k1p*voronoiDiagram[i].GTP+k2p*voronoiDiagram[i].GTP*voronoiDiagram[i].GTP)*voronoiDiagram[i].GDP*(Ec/volume)+(k1n+k2n*voronoiDiagram[i].totGAP)*voronoiDiagram[i].GTP-rand*r_noise*voronoiDiagram[i].GDP; 
					reactionGAP[i]=k3n*Math.pow(voronoiDiagram[i].GTP,h)/(Math.pow(c_sat,h)+Math.pow(voronoiDiagram[i].GTP,h)) -r_GAP*voronoiDiagram[i].GAP;      ///(k+voronoiDiagram[i].GTP)  
					reactionGAPlabeled[i]=k3n*Math.pow(voronoiDiagram[i].GTP,h)/(Math.pow(c_sat,h)+Math.pow(voronoiDiagram[i].GTP,h)) -r_GAP*voronoiDiagram[i].GAPlabeled;  ///(k+voronoiDiagram[i].GTP)
			}
		}
		
		for(int i=0;i<totNumNodes;i++){
			voronoiDiagram[i].GTP=voronoiDiagram[i].GTP+(dt/voronoiDiagram[i].area)*totalFluxGTP[i]+dt*reaction[i];
			voronoiDiagram[i].GDP=voronoiDiagram[i].GDP+(dt/voronoiDiagram[i].area)*totalFluxGDP[i]+dt*reactionGDP[i];
			voronoiDiagram[i].GAP=voronoiDiagram[i].GAP+(dt/voronoiDiagram[i].area)*totalFluxGAP[i]+dt*reactionGAP[i];
			voronoiDiagram[i].GAPlabeled=voronoiDiagram[i].GAPlabeled+(dt/voronoiDiagram[i].area)*totalFluxGAPlabeled[i]+dt*reactionGAPlabeled[i];
			voronoiDiagram[i].totGAP=voronoiDiagram[i].GAP+voronoiDiagram[i].GAPlabeled;

		}
		if(showAnimation){
		plotCells();
		frame5.setMessage("time= "+ControlUtils.f2(time));
		frame6.setMessage("time= "+ControlUtils.f2(time));
		frame7.setMessage("time= "+ControlUtils.f2(time));
		}
	}
	
	public void RunModel(){
		while(!this.isFinished()){
			this.doStep(showAnimation); 
		} // end while 

		this.closingCommands(); 
		
	} // end RunModel 
	
	public void reset(){
		ModelFinished = false;
		time=0.;
	}
	
	public void SaveDataStep(double Ec,double V,double t){
		double[] GAPdata = new double[totNumNodes];
		double[] GTPdata = new double[totNumNodes];
		double[] GDPdata = new double[totNumNodes];
		double[] GAPrecruitment_data = new double[totNumNodes];
		double[] GEFdata = new double[totNumNodes];
		double[] EcTimeData={t,Ec};
		for(int i=0;i<totNumNodes;i++){
			GAPdata[i]=voronoiDiagram[i].totGAP;
			GTPdata[i]=voronoiDiagram[i].GTP;
			GDPdata[i]=voronoiDiagram[i].GDP;
			GAPrecruitment_data[i]=k3n*Math.pow(voronoiDiagram[i].GTP,h)/(Math.pow(c_sat,h)+Math.pow(voronoiDiagram[i].GTP,h));
			GEFdata[i]=(k1p*voronoiDiagram[i].GTP+k2p*voronoiDiagram[i].GTP*voronoiDiagram[i].GTP)*(Ec/V);		
		}
		
		//System.out.println("Gap[0]="+GAPdata[0]+"           GTP[0]="+GTPdata[0]+"         GDP[0]="+GDPdata[0]+"            GAPrecruitment[0]="+GAPrecruitment_data[0]+"         GEF[0]="+GEFdata[0]+"         Ec[0]="+EcTimeData[0]+"         Ec[1]="+EcTimeData[1]);
		GAP.addData(GAPdata);
		GTP.addData(GTPdata);
		GDP.addData(GDPdata);
		GEF.addData(GEFdata);
		GAPrecruitment.addData(GAPrecruitment_data);
		EcTimeValues.addData(EcTimeData);
	}
	
	public boolean isFinished(){
		return ModelFinished; 
	}
	
	public void closingCommands(){
		GAP.WriteToFile();
		GTP.WriteToFile();
		GDP.WriteToFile();
		GEF.WriteToFile();
		GAPrecruitment.WriteToFile();
		EcTimeValues.WriteToFile();
		
		for(int i=0;i<totNumNodes;i++){
		ArrayList<Double> list=new ArrayList<Double>();
		list.add((double) i);
		list.add( voronoiDiagram[i].area);
		double[] areaData=new double[list.size()];
		for(int iter=0;iter<list.size();iter++){
			areaData[iter]=list.get(iter);
		}
		Area.addData(areaData);
	}
	Area.WriteToFile();
		
	System.out.println("--------------------Simulation finished--------------");
	}
	


	// EVOLVE MODEL END

	// PLOTS START
		public void concentrationPlot(){
			frame5=new Display3DFrame("Ras1");
			frame6=new Display3DFrame("GAP");
			frame7=new Display3DFrame("testRas1");
			Ras1GTPArc=new PlotFrame("distance","Ras1GTP Concentration","Ras1GTP vs Distance");
			Ras1GDPArc=new PlotFrame("distance","Ras1GDP Concentration","Ras1GDP vs Distance");
			Gap1Arc=new PlotFrame("distance","Gap1 Concentration","Gap1 vs Distance");
			GefArc=new PlotFrame("distance","Gef Concentration","Gef vs Distance");
			GefCyto = new PlotFrame("time","Ecyto","Ecyto vs time");
			frame5.setPreferredMinMax(-1*radius,radius,-1*radius,radius,-1*length/2,length/2); 
			frame6.setPreferredMinMax(-1*radius,radius,-1*radius,radius,-1*length/2,length/2);
			frame7.setPreferredMinMax(-1*radius,radius,-1*radius,radius,-1*length/2,length/2);
			polygon=new ElementPolygon[totNumNodes];
			polygontest=new ElementPolygon[totNumNodes];
			polygon2=new ElementPolygon[totNumNodes];
			polygon3=new ElementPolygon[totNumNodes];
			for(int i=0;i<totNumNodes;i++){
				polygon[i]= new  ElementPolygon();
				polygon[i].setClosed(true);
				polygon[i].setData(voronoiDiagram[i].vertex);	
				Color color=new Color(255,(int)(255-voronoiDiagram[i].GTP/(3*Math.pow(10, 5))),(int)(255-voronoiDiagram[i].GTP/(3*Math.pow(10, 5))));
				polygon[i].getStyle().setFillColor(color);
				frame5.addElement(polygon[i]);
				polygontest[i]= new  ElementPolygon();
				polygontest[i].setClosed(true);
				polygontest[i].setData(voronoiDiagram[i].vertex);	
				polygontest[i].getStyle().setFillColor(color);
				frame7.addElement(polygontest[i]);
				polygon2[i]= new  ElementPolygon();
				polygon2[i].setClosed(true);
				polygon2[i].setData(voronoiDiagram[i].vertex);	
				Color color2=new Color(255,255,255);
				polygon2[i].getStyle().setFillColor(color2);
				frame6.addElement(polygon2[i]);
				polygon3[i]= new  ElementPolygon();
				polygon3[i].setClosed(true);
				polygon3[i].setData(voronoiDiagram[i].vertex);	
				polygon3[i].getStyle().setFillColor(color2);
				}
			}

		public void plotCells(){
			maxGap1=0;
			for(int i=0;i<totNumNodes;i++){
				maxGap1 += voronoiDiagram[i].totGAP;
			}
			
			double maxGTPratioPixel=voronoiDiagram[0].GTP/(voronoiDiagram[0].GTP+voronoiDiagram[0].GDP+1);
			double currentGTPratioPixel=voronoiDiagram[0].GTP/(voronoiDiagram[0].GTP+voronoiDiagram[0].GDP+1);
			int i_maxGTPratioPixel=0;
			for(int i=0;i<totNumNodes;i++){
				currentGTPratioPixel=voronoiDiagram[i].GTP/(voronoiDiagram[i].GTP+voronoiDiagram[i].GDP+1);
				if(currentGTPratioPixel>maxGTPratioPixel){
					maxGTPratioPixel=currentGTPratioPixel;
					i_maxGTPratioPixel=i;
				}
			}
			double Phi_ref=Math.asin(voronoiDiagram[i_maxGTPratioPixel].center[1]/Math.sqrt(Math.pow(voronoiDiagram[i_maxGTPratioPixel].center[0],2)+Math.pow(voronoiDiagram[i_maxGTPratioPixel].center[1],2)));
			if(voronoiDiagram[i_maxGTPratioPixel].center[0]<0){
				//if(voronoiDiagram[i_maxGTPratioPixel].center[1]>0)
					Phi_ref=Math.PI-Phi_ref;	
				}
				else{
					if(voronoiDiagram[i_maxGTPratioPixel].center[1]<0)
						Phi_ref=2*Math.PI+Phi_ref;
				}
			
			for(int i=0;i<totNumNodes;i++){
				Color color,color2;
				double Phi=Math.asin(voronoiDiagram[i].center[1]/Math.sqrt(Math.pow(voronoiDiagram[i].center[0],2)+Math.pow(voronoiDiagram[i].center[1],2)));
				if(voronoiDiagram[i].center[0]<0){
					//if(voronoiDiagram[i].center[1]>0)
						Phi=Math.PI-Phi;
				}
				else{
					if(voronoiDiagram[i].center[1]<0)
						Phi=2*Math.PI+Phi;
				}
				if((voronoiDiagram[i].GTP/(voronoiDiagram[i].GTP+voronoiDiagram[i].GDP+1)*255<0 || (voronoiDiagram[i].GTP/(voronoiDiagram[i].GTP+voronoiDiagram[i].GDP+1)*255>255)) || (voronoiDiagram[i].GDP/(voronoiDiagram[i].GTP+voronoiDiagram[i].GDP+1)*255<0 || (voronoiDiagram[i].GDP/(voronoiDiagram[i].GTP+voronoiDiagram[i].GDP+1)*255>255)))
					System.out.println((voronoiDiagram[i].GTP/(voronoiDiagram[i].GTP+voronoiDiagram[i].GDP+1)*255)+"      -----------------         "+voronoiDiagram[i].GDP/(voronoiDiagram[i].GTP+voronoiDiagram[i].GDP+1)*255);
				color=new Color((int) (voronoiDiagram[i].GTP/(voronoiDiagram[i].GTP+voronoiDiagram[i].GDP+1)*255),0,(int) (voronoiDiagram[i].GDP/(voronoiDiagram[i].GTP+voronoiDiagram[i].GDP+1)*255));
				polygontest[i].getStyle().setFillColor(color);
				if(Phi<Phi_ref+ly/(2*radius) && Phi>Phi_ref-ly/(2*radius)){
					color=Color.WHITE;
				}
				polygon[i].getStyle().setFillColor(color);
				if(voronoiDiagram[i].GAPlabeled>=0 && voronoiDiagram[i].GAPlabeled<5*maxGap1/totNumNodes)
					color2=new Color(0,(int) (voronoiDiagram[i].GAPlabeled/(5*maxGap1/totNumNodes)*255),0);
				else if(voronoiDiagram[i].GAPlabeled>5*maxGap1/totNumNodes && voronoiDiagram[i].GAPlabeled<10*maxGap1/totNumNodes)
					color2=new Color((int) (voronoiDiagram[i].GAPlabeled/(10*maxGap1/totNumNodes)*255),255,0);
				else if(voronoiDiagram[i].GAPlabeled>10*maxGap1/totNumNodes && voronoiDiagram[i].GAPlabeled<(20*maxGap1/totNumNodes))
					color2=new Color(255,255,(int) (voronoiDiagram[i].GAPlabeled/(20*maxGap1/totNumNodes)*255));
				else if(voronoiDiagram[i].GAPlabeled<0){
					color2=Color.black;
					System.out.println("GAP concentration is negative on some of the voronoi diagrams.");
				}
				else{
					color2=Color.black;
					//System.out.println("GAP concentration is not in the range of color spectrum. voronoiDiagram[i].GAPlabeled="+voronoiDiagram[i].GAPlabeled+"               (maxGap1/totNumNodes)"+(maxGap1/totNumNodes));
				}
				polygon2[i].getStyle().setFillColor(color2);
			}
			
		}

		public void plotRas1Arc(int a){
			double Phi_ref=Math.asin(voronoiDiagram[a].center[1]/Math.sqrt(Math.pow(voronoiDiagram[a].center[0],2)+Math.pow(voronoiDiagram[a].center[1],2)));
			if(voronoiDiagram[a].center[0]<0){
					Phi_ref=Math.PI-Phi_ref;	
				}
				else{
					if(voronoiDiagram[a].center[1]<0)
						Phi_ref=2*Math.PI+Phi_ref;
				}
			
			for(int i=0;i<totNumNodes;i++){
				double Phi=Math.asin(voronoiDiagram[i].center[1]/Math.sqrt(Math.pow(voronoiDiagram[i].center[0],2)+Math.pow(voronoiDiagram[i].center[1],2)));
				if(voronoiDiagram[i].center[0]<0){
						Phi=Math.PI-Phi;
				}
				else{
					if(voronoiDiagram[i].center[1]<0)
						Phi=2*Math.PI+Phi;
				}
				
				if(Phi<Phi_ref+ly/(2*radius) && Phi>Phi_ref-ly/(2*radius)){
					double cvalue = voronoiDiagram[i].GDP;
					double cvalue1=voronoiDiagram[i].GTP;
					double svalue = voronoiDiagram[i].distanceFromTheLowerTip(length, radius);
						Ras1GDPArc.append(colorplot,svalue,cvalue);
						Ras1GTPArc.append(colorplot,svalue,cvalue1);
				}
			}
			colorplot++;
		}
		public void plotGap1Arc(){
			double rw = 0.1;
			for(int i=0;i<totNumNodes;i++){
				if(voronoiDiagram[i].center[1]<rw && voronoiDiagram[i].center[1] > -rw){
					double cvalue = voronoiDiagram[i].totGAP;
					double svalue = voronoiDiagram[i].distanceFromTheLowerTip(length, radius);
					if (voronoiDiagram[i].center[0]<0.) svalue = 0.-svalue;
					Gap1Arc.append(colorplot,svalue,cvalue);
				}
			}
			colorplot++;
		}
		public void plotGap1Arc(int a){
			double Phi_ref=Math.asin(voronoiDiagram[a].center[1]/Math.sqrt(Math.pow(voronoiDiagram[a].center[0],2)+Math.pow(voronoiDiagram[a].center[1],2)));
			if(voronoiDiagram[a].center[0]<0){
					Phi_ref=Math.PI-Phi_ref;	
				}
				else{
					if(voronoiDiagram[a].center[1]<0)
						Phi_ref=2*Math.PI+Phi_ref;
				}
			
			for(int i=0;i<totNumNodes;i++){
				double Phi=Math.asin(voronoiDiagram[i].center[1]/Math.sqrt(Math.pow(voronoiDiagram[i].center[0],2)+Math.pow(voronoiDiagram[i].center[1],2)));
				if(voronoiDiagram[i].center[0]<0){
						Phi=Math.PI-Phi;
				}
				else{
					if(voronoiDiagram[i].center[1]<0)
						Phi=2*Math.PI+Phi;
				}
				
				if(Phi<Phi_ref+ly/(2*radius) && Phi>Phi_ref-ly/(2*radius)){
					double cvalue = voronoiDiagram[i].totGAP;
					double svalue = voronoiDiagram[i].distanceFromTheLowerTip(length, radius);
					Gap1Arc.append(colorplot,svalue,cvalue);
				}
			}
			colorplot++;
		}
		public void plotGefArc(double Ec,double volume,int a){
			double Phi_ref=Math.asin(voronoiDiagram[a].center[1]/Math.sqrt(Math.pow(voronoiDiagram[a].center[0],2)+Math.pow(voronoiDiagram[a].center[1],2)));
			if(voronoiDiagram[a].center[0]<0){
					Phi_ref=Math.PI-Phi_ref;	
				}
				else{
					if(voronoiDiagram[a].center[1]<0)
						Phi_ref=2*Math.PI+Phi_ref;
				}
			
			for(int i=0;i<totNumNodes;i++){
				double Phi=Math.asin(voronoiDiagram[i].center[1]/Math.sqrt(Math.pow(voronoiDiagram[i].center[0],2)+Math.pow(voronoiDiagram[i].center[1],2)));
				if(voronoiDiagram[i].center[0]<0){
						Phi=Math.PI-Phi;
				}
				else{
					if(voronoiDiagram[i].center[1]<0)
						Phi=2*Math.PI+Phi;
				}
				
				if(Phi<Phi_ref+ly/(2*radius) && Phi>Phi_ref-ly/(2*radius)){
					double cvalue = (k1p*voronoiDiagram[i].GTP+k2p*voronoiDiagram[i].GTP*voronoiDiagram[i].GTP)*Ec/volume;
					double svalue = voronoiDiagram[i].distanceFromTheLowerTip(length, radius);
					GefArc.append(colorplot,svalue,cvalue);
				}
			}
			colorplot++;
		}

		// PLOTS END

	// FOLLOWING: GENERATE THE GEOMETRY

	public void Geometry(){
		//frame.setPreferredMinMax(-1*radius,radius,-1*radius,radius,-1*length/2,length/2); 
		sphere1= new ElementSphere(radius);
		sphere2= new ElementSphere(radius);
		cylinder= new ElementCylinder();
		sphere1.setXYZ(0.,0.,(length-2*radius)/2.);
		sphere2.setXYZ(0.,0.,-(length-2*radius)/2.);
		cylinder.setXYZ(0.,0.,0.);
		cylinder.setSizeXYZ(2*radius,2*radius,length-2*radius);
		cylinder.getStyle().setDrawingLines(false);
		sphere1.getStyle().setDrawingLines(false);
		sphere2.getStyle().setDrawingLines(false);
		cylinder.getStyle().setFillColor(Color.cyan);
		sphere1.getStyle().setFillColor(Color.cyan);
		sphere2.getStyle().setFillColor(Color.cyan);	
		//frame.addElement(sphere1);
		//frame.addElement(sphere2);
		//frame.addElement(cylinder);
	}

	public void surfaceNodeInit(){
		//System.out.println("nx="+nx+"		ny="+ny+"		nz="+nz+"		length="+length+"		radius="+radius+"		lx="+lx+"		ly="+ly+"		lz="+lz);
		//int counter=0;
		surfaceNode= new nodeInitialization[3][nx+1][ny+1][nz+1];
		for(int i=0;i<nx+1;i++){
			for(int j=0;j<ny+1;j++){
				for(int k=0;k<nz+1;k++){
					surfaceNode[0][i][j][k]=new nodeInitialization(i,j,k,nx,ny,nz,length,radius,-1*radius,-1*radius+0.5*ly,-1*length/2+0.5*lz);   //perpendicular to x axis
					surfaceNode[2][i][j][k]=new nodeInitialization(i,j,k,nx,ny,nz,length,radius,-1*radius+0.5*lx,-1*radius+0.5*ly,-1*length/2);    //perpendicular to z axis
					surfaceNode[1][i][j][k]=new nodeInitialization(i,j,k,nx,ny,nz,length,radius,-1*radius+0.5*lx,-1*radius,-1*length/2+0.5*lz);
					//counter=counter+3;
				}
			}
		}
		//System.out.println("total="+counter);
	}

	public void surfacePoints(){
		//frame1.setPreferredMinMax(-1*radius,radius,-1*radius,radius,-1*length/2,length/2); 
		surfacePoint=new ElementSphere[(nx+1)*ny*nz+nx*(ny+1)*nz+nx*ny*(nz+1)];
		int iter=0;
		for(int i=0;i<nx+1;i++){
			for(int j=0;j<ny;j++){
				for(int k=0;k<nz;k++){
					surfacePoint[iter]= new ElementSphere(0.02); //0.02 is the radius of points that are shown on the plot
	                surfacePoint[iter].setXYZ(surfaceNode[0][i][j][k].position[0], surfaceNode[0][i][j][k].position[1], surfaceNode[0][i][j][k].position[2]);
	                surfacePoint[iter].getStyle().setFillColor(Color.RED);
	                surfacePoint[iter].getStyle().setDrawingLines(false);
	                //if(surfaceNode[0][i][j][k].geometryStatus==1)
		            //frame1.addElement(surfacePoint[iter]);
	                iter++;
				}
			}	
		}
		for(int k=0;k<nz+1;k++){
			for(int i=0;i<nx;i++){
				for(int j=0;j<ny;j++){
					surfacePoint[iter]= new ElementSphere(0.02); //0.02 is the radius of points that are shown on the plot
	                surfacePoint[iter].setXYZ(surfaceNode[2][i][j][k].position[0], surfaceNode[2][i][j][k].position[1], surfaceNode[2][i][j][k].position[2]);
	                surfacePoint[iter].getStyle().setFillColor(Color.GREEN);
	                surfacePoint[iter].getStyle().setDrawingLines(false);
	                //if(surfaceNode[0][i][j][k].geometryStatus==1)
		            //frame1.addElement(surfacePoint[iter]);
		            iter++;
				}
			}	
		}
		for(int j=0;j<ny+1;j++){
			for(int k=0;k<nz;k++){
				for(int i=0;i<nx;i++){
					surfacePoint[iter]= new ElementSphere(0.02); //0.02 is the radius of points that are shown on the plot
	                surfacePoint[iter].setXYZ(surfaceNode[1][i][j][k].position[0], surfaceNode[1][i][j][k].position[1], surfaceNode[1][i][j][k].position[2]);
	                surfacePoint[iter].getStyle().setFillColor(Color.BLUE);
	                surfacePoint[iter].getStyle().setDrawingLines(false);
	                //if(surfaceNode[0][i][j][k].geometryStatus==1)
		            //frame1.addElement(surfacePoint[iter]);
	                iter++;
				}
			}	
		}
		
	}

	public void geometryStatusInit(){
		int NumNodesInside=0;
		int NumNodesOutside=0;
		double[] center=new double[3];
		for(int i=0;i<nx+1;i++){
			for(int j=0;j<ny+1;j++){
				for(int k=0;k<nz+1;k++){
					if(j!=ny+1 && k!=nz+1){
						if(i<(nx+1)/2){
							center[0]=(surfaceNode[0][i][j][k].position[0]+surfaceNode[0][i+1][j][k].position[0])/2;
							center[1]=surfaceNode[0][i][j][k].position[1];
							center[2]=surfaceNode[0][i][j][k].position[2];
							surfaceNode[0][i][j][k].getGeometryStatus(center);
							/*if(surfaceNode[0][i][j][k].geometryStatus==1)
							pixelatedGeometry(center);*/
						}
						else{
							center[0]=(surfaceNode[0][i][j][k].position[0]+surfaceNode[0][i-1][j][k].position[0])/2;
							center[1]=surfaceNode[0][i][j][k].position[1];
							center[2]=surfaceNode[0][i][j][k].position[2];
							surfaceNode[0][i][j][k].getGeometryStatus(center);
							/*if(surfaceNode[0][i][j][k].geometryStatus==1)
							pixelatedGeometry(center);*/
						}
					}
					if(k!=nz+1 && i!=nx+1){
						if(j<(ny+1)/2){
							center[0]=surfaceNode[1][i][j][k].position[0];
							center[1]=(surfaceNode[1][i][j][k].position[1]+surfaceNode[1][i][j+1][k].position[1])/2;
							center[2]=surfaceNode[1][i][j][k].position[2];
							surfaceNode[1][i][j][k].getGeometryStatus(center);
							/*if(surfaceNode[1][i][j][k].geometryStatus==1)
							pixelatedGeometry(center);*/
							}
							else{
								center[0]=surfaceNode[1][i][j][k].position[0];
								center[1]=(surfaceNode[1][i][j][k].position[1]+surfaceNode[1][i][j-1][k].position[1])/2;
								center[2]=surfaceNode[1][i][j][k].position[2];
								surfaceNode[1][i][j][k].getGeometryStatus(center);
								/*if(surfaceNode[1][i][j][k].geometryStatus==1)
								pixelatedGeometry(center);*/
							}
					}
					if(i!=nx+1 && j!=ny+1){
						if(k<(nz+1)/2){
							center[0]=surfaceNode[2][i][j][k].position[0];
							center[1]=surfaceNode[2][i][j][k].position[1];
							center[2]=(surfaceNode[2][i][j][k].position[2]+surfaceNode[2][i][j][k+1].position[2])/2;
							surfaceNode[2][i][j][k].getGeometryStatus(center);
							//if(surfaceNode[2][i][j][k].geometryStatus==1)
							//pixelatedGeometry(center);
							}
							else{
								center[0]=surfaceNode[2][i][j][k].position[0];
								center[1]=surfaceNode[2][i][j][k].position[1];
								center[2]=(surfaceNode[2][i][j][k].position[2]+surfaceNode[2][i][j][k-1].position[2])/2;
								surfaceNode[2][i][j][k].getGeometryStatus(center);
								///if(surfaceNode[2][i][j][k].geometryStatus==1)
								//pixelatedGeometry(center);
							}
					}
					if((i==nx+1 && j==ny+1) || (i==nx+1 && k==nz+1) || (j==ny+1 && k==nz+1)){
						surfaceNode[0][i][j][k].geometryStatus=0;
						surfaceNode[1][i][j][k].geometryStatus=0;
						surfaceNode[2][i][j][k].geometryStatus=0;
					}
					if(surfaceNode[0][i][j][k].geometryStatus==1) NumNodesInside++;
					else NumNodesOutside++;
					if(surfaceNode[1][i][j][k].geometryStatus==1) NumNodesInside++;
					else NumNodesOutside++;
					if(surfaceNode[2][i][j][k].geometryStatus==1) NumNodesInside++;
					else NumNodesOutside++;
				}
			}
		}
		System.out.println("total Number of Surface Nodes inside Geometry is="+NumNodesInside+ "		surface Nodes outside="+NumNodesOutside);
	}

	public void concentrationStatusInit(){  
		for(int j=0;j<ny;j++){
			for(int k=0;k<nz;k++){
				boolean flag=true;
				int min=100;
				int max=100;
				for(int i=0;i<nx+1;i++){
					surfaceNode[0][i][j][k].concentrationStatus=0;
					if(surfaceNode[0][i][j][k].geometryStatus==1 && flag==true){
						min=i;
						max=i;
						flag=false;	
					}
					if(flag==false && i!=nx && surfaceNode[0][max][j][k].position[0]<surfaceNode[0][max+1][j][k].position[0] && surfaceNode[0][max+1][j][k].geometryStatus==1)
						max=max+1;	
				}	
				if(flag==false){
					surfaceNode[0][min][j][k].concentrationStatus=1;
					surfaceNode[0][max][j][k].concentrationStatus=1;
					double[] direction=new double[3];
					double[] direction1=new double[3];
					direction1[0]=0;
					direction1[1]=ly;
					direction1[2]=0;
					direction[0]=0;
					direction[1]=0;
					direction[2]=lz;
					SP(surfaceNode[0][min][j][k].position,direction, direction1);
					SP(surfaceNode[0][max][j][k].position,direction, direction1);
					}
				}
			}
		for(int k=0;k<nz;k++){
			for(int i=0;i<nx;i++){
				boolean flag=true;
				int min=100;
				int max=100;
				for(int j=0;j<ny+1;j++){
					surfaceNode[1][i][j][k].concentrationStatus=0;
					if(surfaceNode[1][i][j][k].geometryStatus==1 && flag==true){
						min=j;
						max=j;
						flag=false;	
					}
					if(flag==false && j!=ny && surfaceNode[1][i][max][k].position[1]<surfaceNode[1][i][max+1][k].position[1] && surfaceNode[1][i][max+1][k].geometryStatus==1)
						max=max+1;	
				}	
				if(flag==false){
					surfaceNode[1][i][min][k].concentrationStatus=1;
					surfaceNode[1][i][max][k].concentrationStatus=1;
					double[] direction=new double[3];
					double[] direction1=new double[3];
					direction1[0]=lx;
					direction1[1]=0;
					direction1[2]=0;
					direction[0]=0;
					direction[1]=0;
					direction[2]=lz;
					SP(surfaceNode[1][i][min][k].position,direction, direction1);
					SP(surfaceNode[1][i][max][k].position,direction, direction1);
					}
				}
			}
		for(int i=0;i<nx;i++){
			for(int j=0;j<ny;j++){
				boolean flag=true;
				int min=100;
				int max=100;
				for(int k=0;k<nz+1;k++){
					surfaceNode[2][i][j][k].concentrationStatus=0;
					if(surfaceNode[2][i][j][k].geometryStatus==1 && flag==true){
						min=k;
						max=k;
						flag=false;	
					}
					if(flag==false && k!=nz && surfaceNode[2][i][j][max].position[2]<surfaceNode[2][i][j][max+1].position[2] && surfaceNode[2][i][j][max+1].geometryStatus==1)
						max=max+1;	
				}	
				if(flag==false){
					surfaceNode[2][i][j][min].concentrationStatus=1;
					surfaceNode[2][i][j][max].concentrationStatus=1;
					double[] direction=new double[3];
					double[] direction1=new double[3];
					direction1[0]=lx;
					direction1[1]=0;
					direction1[2]=0;
					direction[0]=0;
					direction[1]=ly;
					direction[2]=0;
					SP(surfaceNode[2][i][j][min].position,direction, direction1);
					SP(surfaceNode[2][i][j][max].position,direction, direction1);
					}
				}
			}
		}

	public void SP(double[] position,double[] direction, double[] direction1){ //plots a surface plane of the cube[i][j][k] and the center point
		//frame2.setPreferredMinMax(-1*radius,radius,-1*radius,radius,-1*length/2,length/2);  
		ElementSphere SP;
		SP=new ElementSphere(0.02);
		SP.setXYZ(position[0],position[1],position[2]);
		SP.getStyle().setFillColor(Color.RED);
		SP.getStyle().setDrawingLines(false);
		//frame2.addElement(SP);
		ElementPlane p;
		p=new ElementPlane();
		p.setXYZ(position[0],position[1],position[2]);
		p.setFirstDirection(direction);
		p.setSecondDirection(direction1);
		p.getStyle().setResolution(null);
		p.getStyle().setFillColor(Color.CYAN);
		p.getStyle().setDrawingLines(true);
		//frame2.addElement(p);
	}

	public void initializeNodeNumbers(){
		int iter=0;
		for(int s=0;s<3;s++){
			for(int i=0;i<nx+1;i++){
				for(int j=0;j<ny+1;j++){
					for(int k=0;k<nz+1;k++){
						if(surfaceNode[s][i][j][k].concentrationStatus==1){
							surfaceNode[s][i][j][k].numOfNode=iter;
							iter++;
						}
					}
				}
			}
		}
		totNumNodes=iter;  //total number of surface nodes 
		System.out.println("numberOfSurfaceNodes="+totNumNodes);
	}

	public void findingNeighbors(){
		voronoiDiagram=new VoronoiDiagram[totNumNodes];
		sGeodesic=new double[totNumNodes][totNumNodes];
		dGeodesic=new double[totNumNodes][totNumNodes];
		for(int i=0;i<totNumNodes;i++){
			for(int j=0;j<totNumNodes;j++){
				sGeodesic[i][j]=0;
				dGeodesic[i][j]=0;
			}
		}
		int n_s=1;
		int n_i=7;
		int n_j=ny;
		int n_k=15;
		for(int s=0;s<3;s++){
			for(int i=0;i<nx+1;i++){
				for(int j=0;j<ny+1;j++){
					for(int k=0;k<nz+1;k++){
						if(surfaceNode[s][i][j][k].concentrationStatus==1){
							double[] normal=new double[3];
							normal=normalVector(s,i,j,k);
							if(s==n_s && i==n_i && j==n_j && k==n_k){
								//control.println("normal[0]= "+normal[0]+"		normal[1]= "+normal[1]+"		normal[2]= "+normal[2]+"		length= "+(Math.sqrt(Math.pow(normal[0], 2)+Math.pow(normal[1], 2)+Math.pow(normal[2], 2))));
								ElementArrow v=new ElementArrow();
								v.setXYZ(surfaceNode[s][i][j][k].position[0], surfaceNode[s][i][j][k].position[1], surfaceNode[s][i][j][k].position[2]);
								v.setSizeXYZ(normal[0], normal[1], normal[2]);
								v.getStyle().setFillColor(Color.black);
							}
							ArrayList<Double[]> arrayOfNeighbors=new ArrayList<Double[]>(); 
							arrayOfNeighbors=findNeighbors(s,i,j,k);
							double[][] projection=new double[arrayOfNeighbors.size()-1][4]; //the cell that I am looking for the neighbors is one of the neighbors and must be elliminated for projections, the 4th argument is the number of the neighbor node in the whole structure
							int iter=0;
							for(int t=0;t<arrayOfNeighbors.size();t++){
								Double[] neighbor=new Double[5];  //first 3 arguments are position coordinates,4th one is the direction of normal of the plane and 5th one is the number of the neighbor node in the whole structure
								neighbor=arrayOfNeighbors.get(t);
								if(surfaceNode[s][i][j][k].position[0]!=neighbor[0] || surfaceNode[s][i][j][k].position[1]!=neighbor[1] || surfaceNode[s][i][j][k].position[2]!=neighbor[2]){
									projection[iter]=projectingTheNeighbor(neighbor,normal,surfaceNode[s][i][j][k].position);
									iter++;
								}
							}
							projection=sortProjection(projection,surfaceNode[s][i][j][k].position,normal,(arrayOfNeighbors.size()-1));
							if(s==n_s && i==n_i && j==n_j && k==n_k){
								projection=sortProjection(projection,surfaceNode[s][i][j][k].position,normal,(arrayOfNeighbors.size()-1));
								
								for(int t=0;t<(arrayOfNeighbors.size()-1);t++){
									ElementSphere sphere=new ElementSphere();
									sphere.setXYZ(projection[t]);
					                sphere.getStyle().setFillColor(Color.black);
					                sphere.getStyle().setDrawingLines(false);
					                sphere.setRadius(0.03);
								}
							}
							voronoiDiagram[surfaceNode[s][i][j][k].numOfNode]=new VoronoiDiagram(surfaceNode[s][i][j][k].position, normal, projection);
							voronoiDiagram[surfaceNode[s][i][j][k].numOfNode].getVoronoiDiagramVertices();
							voronoiDiagram[surfaceNode[s][i][j][k].numOfNode].Geodesic();
							for(int t=0;t<(arrayOfNeighbors.size()-1);t++){
								sGeodesic[surfaceNode[s][i][j][k].numOfNode][(int)projection[t][3]]=voronoiDiagram[surfaceNode[s][i][j][k].numOfNode].s[t];
								dGeodesic[surfaceNode[s][i][j][k].numOfNode][(int)projection[t][3]]=voronoiDiagram[surfaceNode[s][i][j][k].numOfNode].d[t];
							}
						}	
					}
				}
			}
		}
	}

	public void symmetrization(){
		for(int i=0;i<totNumNodes;i++){
			for(int j=0;j<totNumNodes;j++){
				if(j>i){
					sGeodesic[i][j]=(sGeodesic[i][j]+sGeodesic[j][i])/2;
					dGeodesic[i][j]=(dGeodesic[i][j]+dGeodesic[j][i])/2;
				}
				else{
					sGeodesic[i][j]=sGeodesic[j][i];
					dGeodesic[i][j]=dGeodesic[j][i];
				}
			}
		}
	}

	public double calculationOfVoronoiDiagramsArea(){
		double totalArea=0.;
		for(int i=0;i<totNumNodes;i++){
			for(int j=0;j<totNumNodes;j++){
				voronoiDiagram[i].area =0;
			}
		}
		for(int i=0;i<totNumNodes;i++){
			for(int j=0;j<totNumNodes;j++){
				voronoiDiagram[i].area += sGeodesic[i][j]*dGeodesic[i][j];		
			}
			voronoiDiagram[i].area = voronoiDiagram[i].area/4;
			totalArea += voronoiDiagram[i].area;
			//System.out.println("number of voronoiDiagram="+i+"			area="+voronoiDiagram[i].area);
		}
		return totalArea;
		//control.println("total num of nodes are:"+totNumNodes+"		total area is="+totalArea);
	}

	public double VolumeCalculation(){
		double volume=0;
		volume= (4*Math.PI*Math.pow(radius, 3)/3) + (Math.PI*Math.pow(radius, 2)*(length-2*radius));
		//System.out.println("sphere volume="+(4*Math.PI*Math.pow(radius, 3)/3)+"             cylinder volume"+(Math.PI*Math.pow(radius, 2)*(length-2*radius)));
		return volume;
	}

	public double[] normalVector(int s,int i, int j, int k){
		double x0=0;  //x0,y0 &z0 are the top sphere origin coordinates
		double y0=0;
		double z0=(length-2*radius)/2.;
		double[] n=new double[3];  //normal vector
		if(Math.abs(surfaceNode[s][i][j][k].position[2])>=z0){  //Finding the normal vector for the closest point to the current surfaceNode on the real surface
			if(surfaceNode[s][i][j][k].position[2]>0){  //for the surfaceNodes corresponding to the upper half sphere
				n[0]=surfaceNode[s][i][j][k].position[0]-x0;
				n[1]=surfaceNode[s][i][j][k].position[1]-y0;
				n[2]=surfaceNode[s][i][j][k].position[2]-z0;
			}
			else{  //for the surfaceNodes corresponding to the bottom half sphere
				n[0]=surfaceNode[s][i][j][k].position[0]-x0;
				n[1]=surfaceNode[s][i][j][k].position[1]-y0;
				n[2]=surfaceNode[s][i][j][k].position[2]-(-1)*z0;
			}
			}
		else if(surfaceNode[s][i][j][k].position[2]<z0 && surfaceNode[s][i][j][k].position[2]>(-1*z0)){  //for the surfaceNode corresponding to the cylinder 
			n[0]=surfaceNode[s][i][j][k].position[0]-x0;
			n[1]=surfaceNode[s][i][j][k].position[1]-y0;
			n[2]=0.;
		}
		n=VectorMath.normalize(n);
		return n;
	}

	public ArrayList<Double[]> findNeighbors(int s, int i,int j,int k){ // right now the node that we are looking for the neighbors is among the neighbors itself
		ArrayList<Double[]> arrayOfNeighbors=new ArrayList<Double[]>(); 
		if(s==0){
			for(int t=0;t<3;t++){  
				for(int m=0;m<ny+1;m++){
					for(int n=0;n<nz+1;n++){
						if(t!=s){
							for(int l=0;l<nx+1;l++){
								if(l==i || l==i-1){
									if(Math.abs(surfaceNode[s][i][j][k].position[1]-surfaceNode[t][l][m][n].position[1])-ly<=Math.pow(10, -7) && Math.abs(surfaceNode[s][i][j][k].position[2]-surfaceNode[t][l][m][n].position[2])-lz<=Math.pow(10, -7)){
										if(surfaceNode[t][l][m][n].concentrationStatus==1){
											Double[] neighbor=new Double[5];
											neighbor[0]=surfaceNode[t][l][m][n].position[0];
											neighbor[1]=surfaceNode[t][l][m][n].position[1];
											neighbor[2]=surfaceNode[t][l][m][n].position[2];
											neighbor[3]=(double) t;
											neighbor[4]=(double) surfaceNode[t][l][m][n].numOfNode;
											arrayOfNeighbors.add(neighbor);
										}
									}	
								}
							}
						}
						else{
							if(Math.abs(surfaceNode[s][i][j][k].position[1]-surfaceNode[t][i][m][n].position[1])-ly<=Math.pow(10, -7) && Math.abs(surfaceNode[s][i][j][k].position[2]-surfaceNode[t][i][m][n].position[2])-lz<=Math.pow(10, -7)){
								if(surfaceNode[t][i][m][n].concentrationStatus==1){
									Double[] neighbor=new Double[5];
									neighbor[0]=surfaceNode[t][i][m][n].position[0];
									neighbor[1]=surfaceNode[t][i][m][n].position[1];
									neighbor[2]=surfaceNode[t][i][m][n].position[2];
									neighbor[3]=(double) t;
									neighbor[4]=(double) surfaceNode[t][i][m][n].numOfNode;
									arrayOfNeighbors.add(neighbor);
								}
							}
						}		
					}
				}
			}
		
		}
		if(s==1){
			for(int t=0;t<3;t++){  
				for(int l=0;l<nx+1;l++){
					for(int n=0;n<nz+1;n++){
						if(t!=s){
							for(int m=0;m<ny+1;m++){
								if(m==j || m==j-1){
									if(Math.abs(surfaceNode[s][i][j][k].position[0]-surfaceNode[t][l][m][n].position[0])-lx<=Math.pow(10, -7) && Math.abs(surfaceNode[s][i][j][k].position[2]-surfaceNode[t][l][m][n].position[2])-lz<=Math.pow(10, -7)){
										if(surfaceNode[t][l][m][n].concentrationStatus==1){
											Double[] neighbor=new Double[5];
											neighbor[0]=surfaceNode[t][l][m][n].position[0];
											neighbor[1]=surfaceNode[t][l][m][n].position[1];
											neighbor[2]=surfaceNode[t][l][m][n].position[2];
											neighbor[3]=(double) t;
											neighbor[4]=(double) surfaceNode[t][l][m][n].numOfNode;
											arrayOfNeighbors.add(neighbor);
										}
									}	
								}
							}
						}
						else{
							if(Math.abs(surfaceNode[s][i][j][k].position[0]-surfaceNode[t][l][j][n].position[0])-lx<=Math.pow(10, -7) && Math.abs(surfaceNode[s][i][j][k].position[2]-surfaceNode[t][l][j][n].position[2])-lz<=Math.pow(10, -7)){
								if(surfaceNode[t][l][j][n].concentrationStatus==1){
									Double[] neighbor=new Double[5];
									neighbor[0]=surfaceNode[t][l][j][n].position[0];
									neighbor[1]=surfaceNode[t][l][j][n].position[1];
									neighbor[2]=surfaceNode[t][l][j][n].position[2];
									neighbor[3]=(double) t;
									neighbor[4]=(double) surfaceNode[t][l][j][n].numOfNode;
									arrayOfNeighbors.add(neighbor);
								}
							}
						}		
					}
				}
			}
		
		}
		if(s==2){
			for(int t=0;t<3;t++){  
				for(int l=0;l<nx+1;l++){
					for(int m=0;m<ny+1;m++){
						if(t!=s){
							for(int n=0;n<nz+1;n++){
								if(n==k || n==k-1){
									if(Math.abs(surfaceNode[s][i][j][k].position[0]-surfaceNode[t][l][m][n].position[0])-lx<=Math.pow(10, -7) && Math.abs(surfaceNode[s][i][j][k].position[1]-surfaceNode[t][l][m][n].position[1])-ly<=Math.pow(10, -7)){
										if(surfaceNode[t][l][m][n].concentrationStatus==1){
											Double[] neighbor=new Double[5];
											neighbor[0]=surfaceNode[t][l][m][n].position[0];
											neighbor[1]=surfaceNode[t][l][m][n].position[1];
											neighbor[2]=surfaceNode[t][l][m][n].position[2];
											neighbor[3]=(double) t;
											neighbor[4]=(double) surfaceNode[t][l][m][n].numOfNode;
											arrayOfNeighbors.add(neighbor);
										}
									}	
								}
							}
						}
						else{
							if(Math.abs(surfaceNode[s][i][j][k].position[0]-surfaceNode[t][l][m][k].position[0])-lx<=Math.pow(10, -7) && Math.abs(surfaceNode[s][i][j][k].position[1]-surfaceNode[t][l][m][k].position[1])-ly<=Math.pow(10, -7)){
								if(surfaceNode[t][l][m][k].concentrationStatus==1){
									Double[] neighbor=new Double[5];
									neighbor[0]=surfaceNode[t][l][m][k].position[0];
									neighbor[1]=surfaceNode[t][l][m][k].position[1];
									neighbor[2]=surfaceNode[t][l][m][k].position[2];
									neighbor[3]=(double) t;
									neighbor[4]=(double) surfaceNode[t][l][m][k].numOfNode;
									arrayOfNeighbors.add(neighbor);
								}
							}
						}		
					}
				}
			}
		
		}
		return arrayOfNeighbors;
	}

	public double[] projectingTheNeighbor(Double[] neighbor,double[] normal,double[] origin){
		double[] projection=new double[4];
		double[] dist=new double[3];
		double dotProduct;
		dist[0]=neighbor[0]-origin[0];
		dist[1]=neighbor[1]-origin[1];
		dist[2]=neighbor[2]-origin[2];
		dotProduct=dist[0]*normal[0]+dist[1]*normal[1]+dist[2]*normal[2];
		projection[0]=neighbor[0]-dotProduct*normal[0];
		projection[1]=neighbor[1]-dotProduct*normal[1];
		projection[2]=neighbor[2]-dotProduct*normal[2];
		projection[3]=neighbor[4];
		return projection;
	}

	public double[][] sortProjection(double[][] projection, double[] position,double[] normal,int numOfNeighbors){
		//System.out.println("num="+(numOfNeighbors-1));
		double[] phi=new double [numOfNeighbors-1];
		double[] v=new double[3];   // a vector between the surface node and the first neighbor
		v[0]=projection[0][0]-position[0];
		v[1]=projection[0][1]-position[1];
		v[2]=projection[0][2]-position[2];
		v=VectorMath.normalize(v);
		//control.println("v(x)= "+v[0]+"		v(y)= "+v[1]+"		v(z)= "+v[2]+"		|v|= "+(Math.sqrt(Math.pow(v[0], 2)+Math.pow(v[1], 2)+Math.pow(v[2], 2))));
		double[] u=new double[3];
		u=VectorMath.cross3D(normal, v);
		//control.println("u(x)= "+u[0]+"		u(y)= "+u[1]+"		u(z)= "+u[2]+"		|u|= "+(Math.sqrt(Math.pow(u[0], 2)+Math.pow(u[1], 2)+Math.pow(u[2], 2))));
		
		//finding the rotation matrix of coordinate system in a way that vector v becomes the x axis and normal vector becomes the z axis then find the rotation
		double[][] r=new double[3][3]; //rotation matrix
		double[][] coeffitionts=new double[3][3];
		coeffitionts[0]=v;
		coeffitionts[1]=u;
		coeffitionts[2]=normal;
		LUPDecomposition LUDecomposition=new LUPDecomposition(coeffitionts);
		double[] result={1.,0.,0.};
		r[0]=LUDecomposition.solve(result);
		double[] result1={0.,1.,0.};
		r[1]=LUDecomposition.solve(result1);
		double[] result2={0.,0.,1.};
		r[2]=LUDecomposition.solve(result2);
		
		//use the rotation for other vectors between the surface node and other neighbors to find the phi angle
		for(int t=1;t<numOfNeighbors;t++){
			//control.println("looking for angles between neighbor number="+t+"and other neighbors");
			double[] f=new double[3];
			f[0]=projection[t][0]-position[0];
			f[1]=projection[t][1]-position[1];
			f[2]=projection[t][2]-position[2];
			f=VectorMath.normalize(f);
			double[] rotatedFVector=new double[3];
			rotatedFVector[0]=r[0][0]*f[0]+r[0][1]*f[1]+r[0][2]*f[2];
			rotatedFVector[1]=r[1][0]*f[0]+r[1][1]*f[1]+r[1][2]*f[2];
			rotatedFVector[2]=r[2][0]*f[0]+r[2][1]*f[1]+r[2][2]*f[2];
			phi[t-1]=Math.atan2(rotatedFVector[1], rotatedFVector[0]);
			if(phi[t-1]<0)
				phi[t-1]=phi[t-1]+2*Math.PI;
			//control.println("phi["+(t-1)+"]="+phi[t-1]);
		}

		//use the phi angle to reorganize the members of the projection matrix then you have the vertices of the polygon neighbor in  order
		double[] buffer=new double[4];
		double buffPhi;
		for(int t=0;t<(numOfNeighbors-1);t++){
			for(int n=t;n<(numOfNeighbors-1);n++){
				if(phi[n]<phi[t]){
					buffer=projection[t+1];
					projection[t+1]=projection[n+1];
					projection[n+1]=buffer;
					buffPhi=phi[t];
					phi[t]=phi[n];
					phi[n]=buffPhi;
				}
			}
		}
		return projection;
	}

	public void pixelatedGeometry(double[] position){
		//frame3.setPreferredMinMax(-1*radius,radius,-1*radius,radius,-1*length/2,length/2);
		//frame3.setDecorationType(1);
		ElementBox box;
		box=new ElementBox();
		box.setSizeXYZ(lx, ly, lz);
		box.setXYZ(position[0],position[1],position[2]);
		box.setDrawQuickInterior(true, 1);
		box.getStyle().setResolution(null); //getting rid of internal segmentations
		//box.getStyle().setDrawingFill(false); //Transparent!
		box.getStyle().setFillColor(Color.CYAN);
		//frame3.addElement(box);
	}
	
	//Set Params
	public void setParameter(String param, double val){
	    if(param.equalsIgnoreCase("DGTP")){
	    	DGTP = val; 
	    }else if(param.equalsIgnoreCase("DGDP")){
	    	DGDP=val;
	    }else if(param.equalsIgnoreCase("DGAP")){
	    	DGAP=val;
	    }else if(param.equalsIgnoreCase("k0p")){
	    	k0p=val;
	    }else if(param.equalsIgnoreCase("k1p")){
	    	k1p=val;
	    }else if(param.equalsIgnoreCase("k2p")){
	    	k2p=val;
	    }else if(param.equalsIgnoreCase("k1n")){
	    	k1n=val;
	    }else if(param.equalsIgnoreCase("k2n")){
	    	k2n=val;
	    }else if(param.equalsIgnoreCase("k3n")){
	    	k3n=val;
	    }else if(param.equalsIgnoreCase("c_sat")){
	    	c_sat=val;
	    }else if(param.equalsIgnoreCase("r_GAP")){
	    	r_GAP=val;
	    }else if(param.equalsIgnoreCase("h")){
	    	h=(int) val;
	    }else if(param.equalsIgnoreCase("r_noise")){
	    	r_noise=val;
	    }else if(param.equalsIgnoreCase("r_GDP")){
	    	r_GDP=val;
	    }else if(param.equalsIgnoreCase("r_GTP")){
	    	r_GTP=val;
	    }else if(param.equalsIgnoreCase("length")){
	    	length=val;
	    }else if(param.equalsIgnoreCase("radius")){
	    	radius=val;
	    }else if(param.equalsIgnoreCase("dt")){
	    	dt=val;
	    }else if(param.equalsIgnoreCase("nx")){
	    	nx=(int) val;
	    }else if(param.equalsIgnoreCase("ny")){
	    	ny=(int) val;
	    }else if(param.equalsIgnoreCase("nz")){
	    	nz=(int) val;
	    }else if(param.equalsIgnoreCase("Smin")){
	    	Smin=val;
	    }else if(param.equalsIgnoreCase("Smax")){
	    	Smax=val;
	    }else if(param.equalsIgnoreCase("T")){
	    	T=val;
	    }else if(param.equalsIgnoreCase("visualizationTime")){
	    	visualizationTime=val;
	    }else if(param.equalsIgnoreCase("lx")){
	    	lx=(double) val;
	    }else if(param.equalsIgnoreCase("ly")){
	    	ly=(double) val;
	    }else if(param.equalsIgnoreCase("lz")){
	    	lz=(double) val;
	    }
	    
	}

	//get Params
		public double getTime(){ return time;}
		public boolean getGraphicsFlag(){ return showAnimation;}
		public void ShowGraphics(boolean b){this.showAnimation = b; } 
		
		public double getParameter(String param){
		    if(param.equalsIgnoreCase("DGTP")){
		    	return DGTP;
		    }else if(param.equalsIgnoreCase("DGDP")){
		    	return DGDP;
		    }else if(param.equalsIgnoreCase("DGAP")){
		    	return DGAP;
		    }else if(param.equalsIgnoreCase("k2n")){
		    	return k2n;
		    }else if(param.equalsIgnoreCase("k0p")){
		    	return k0p;
		    }else if(param.equalsIgnoreCase("k1p")){
		    	return k1p;
		    }else if(param.equalsIgnoreCase("k2p")){
		    	return k2p;
		    }else if(param.equalsIgnoreCase("k1n")){
		    	return k1n;
		    }else if(param.equalsIgnoreCase("length")){
		    	return length;
		    }else if(param.equalsIgnoreCase("radius")){
		    	return radius;
		    }else if(param.equalsIgnoreCase("nx")){
		    	return nx;
		    }else if(param.equalsIgnoreCase("ny")){
		    	return ny;
		    }else if(param.equalsIgnoreCase("nz")){
		    	return nz;
		    }else if(param.equalsIgnoreCase("c_sat")){
		    	return c_sat;
		    }else if(param.equalsIgnoreCase("k3n")){
		    	return k3n;
		    }else if(param.equalsIgnoreCase("r_GAP")){
		    	return r_GAP;
		    }else if(param.equalsIgnoreCase("r_noise")){
		    	return r_noise;
		    }else if(param.equalsIgnoreCase("r_GTP")){
		    	return r_GTP;
		    }else if(param.equalsIgnoreCase("h")){
		    	return h;
		    }else if(param.equalsIgnoreCase("r_GDP")){
		    	return r_GDP;
		    }else if(param.equalsIgnoreCase("dt")){
		    	return dt;
		    }else if(param.equalsIgnoreCase("lx")){
		    	return lx;
		    }else if(param.equalsIgnoreCase("ly")){
		    	return ly;
		    }else if(param.equalsIgnoreCase("lz")){
		    	return lz;
		    }else if(param.equalsIgnoreCase("T")){
		    	return T;
		    }else{
		        System.out.println("Error reading parameter " + param);
		        return -1;
		      }
		}
}


