package diffusion;


public class nodeInitialization {
	double[] position;
	int geometryStatus; //flag that shows if the node is in the pixelated  volume
	int concentrationStatus;  //flag that shows if the node is on the surface of a pixelated geometry
	int numOfNode;
	private double length,radius;
	
	
	nodeInitialization(int i,int j,int k,int nx,int ny,int nz,double length,double radius,double x0,double y0,double z0){
		position=new double[3];
		position[0]=x0+i*2*radius/nx;//x position
		position[1]=y0+j*2*radius/ny;//y position
		position[2]=z0+k*length/nz;//z position
		this.length=length;
		this.radius=radius;
	}
	
	public double[] getPosition(){
		return position;
	}
	
	public int getGeometryStatus(double[] position){ //1 is for nodes inside the cell and 0 for those outside 
		double x0=0;  //x0,y0 &z0 are the top sphere origin coordinates
		double y0=0;
		double z0=(length-2*radius)/2.;
		if(Math.abs(position[2])>(z0-0.0001)){
			double R0=Math.sqrt(Math.pow((position[0]-x0),2)+Math.pow((position[1]-y0),2)+Math.pow((Math.abs(position[2])-z0),2));
			if(R0<(radius+0.0001)){
				geometryStatus=1;
				}
			}
		else if(position[2]<(z0+0.0001) && position[2]>(-1*(z0+0.0001))){
			double R0=Math.sqrt(Math.pow((position[0]-x0),2)+Math.pow((position[1]-y0),2));
			if(R0<radius+0.0001){
				geometryStatus=1;
				}
			}
			else{
				geometryStatus=0;
				}
		return geometryStatus;
	}
}
